Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/account.py
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/account.py	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/account.py	(revision 4663)
@@ -34,4 +34,5 @@
 import accountsetting
 import application
+import call
 
 # Account class
@@ -47,4 +48,5 @@
 		self.cfgChanged = False
 		self.buddyList = []
+                self.callList = []
 
 	def statusText(self):
@@ -73,7 +75,28 @@
 			status = '- not created -'
 		return status
+        
+        def makeCall(self):
+                mycall = call.Call(self.app, self, pj.PJSUA_INVALID_ID)
+                callPrm = pj.CallOpParam()
+                callPrm.opt.audioCount = 1
+                callPrm.opt.videoCount = 0
+                mycall.uri = "sip:test1@pjsip.org"
+                self.callList.append(mycall)
+                mycall.makeCall(mycall.uri, callPrm)
 	
 	def onRegState(self, prm):
 		self.app.updateAccount(self)
+
+        def onIncomingCall(self, prm):
+                mycall = call.Call(self.app, self, prm.callId)
+                self.callList.append(mycall)
+                self.app.updateCall(self)
+                callPrm = pj.CallOpParam()
+                msg = "Incoming call for account '%s'" % self.cfg.idUri
+		if msgbox.askquestion(msg, 'Accept call?', default=msgbox.YES) == u'yes':
+                        callPrm.statusCode = 200
+                        mycall.answer(callPrm)
+                else:
+                        mycall.hangup(callPrm)
 
 
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/application.py
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/application.py	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/application.py	(revision 4663)
@@ -191,4 +191,14 @@
 		self._onTimer()
 
+        def updateCall(self, acc):
+                iid = str(acc.randId)
+                for call in acc.callList:
+                        calliid = str(call.randId)
+                        uri, status = call.statusText()
+                        if self.tv.exists(calliid):
+                                self.tv.item(call.iid, text=uri, values=(status,))
+                        else:
+                                call.iid = self.tv.insert(iid, 0, calliid, open=True, text=uri, values=(status,))
+
 	def updateAccount(self, acc):
 		iid = str(acc.randId)
@@ -270,5 +280,5 @@
 		self.accMenu = tk.Menu(top, tearoff=False)
 		# Labels, must match with _onAccContextMenu()
-		labels = ['Unregister', 'Reregister', 'Add buddy...', '-',
+		labels = ['Call', '-', 'Unregister', 'Reregister', 'Add buddy...', '-',
 			  'Online', 'Invisible', 'Away', 'Busy', '-',
 			  'Settings...', '-',
@@ -351,5 +361,7 @@
 			return
 		
-		if label=='Unregister':
+                if label=='Call':
+                        acc.makeCall()
+		elif label=='Unregister':
 			acc.setRegistration(False)
 		elif label=='Reregister':
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/call.py
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/call.py	(revision 4663)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/pygui/call.py	(revision 4663)
@@ -0,0 +1,69 @@
+# $Id$
+#
+# pjsua Python GUI Demo
+#
+# Copyright (C)2013 Teluu Inc. (http://www.teluu.com)
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+#
+import sys
+if sys.version_info[0] >= 3: # Python 3
+	import tkinter as tk
+	from tkinter import ttk
+	from tkinter import messagebox as msgbox
+else:
+	import Tkinter as tk
+	import tkMessageBox as msgbox
+	import ttk
+
+import random
+import pjsua2 as pj
+import application
+
+# Call class
+class Call(pj.Call):
+	"""
+	High level Python Call object, derived from pjsua2's Call object.
+	"""
+	def __init__(self, app, acc, callId):
+		pj.Call.__init__(self, acc, callId)
+		self.app = app
+                self.acc = acc
+                self.uri = ''
+                self.randId = random.randint(1, 9999)
+
+	def statusText(self):
+                uri = ''
+		status = '?'
+		if self.isActive():
+			ci = self.getInfo()
+                        status = ci.stateText
+                        uri = ci.remoteURI
+		else:
+			status = '- not established -'
+		return uri, status
+	
+	def onCallState(self, prm):
+                ci = self.getInfo()
+                if ci.state == pj.PJSIP_INV_STATE_DISCONNECTED:
+                        iid = str(self.randId)
+			self.acc.callList.remove(self)
+			self.app.tv.delete( (iid,) )
+                        del self
+                else:
+                        self.app.updateCall(self.acc)
+
+if __name__ == '__main__':
+	application.main()
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/samples/pjsua2_demo.cpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/samples/pjsua2_demo.cpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/samples/pjsua2_demo.cpp	(revision 4663)
@@ -24,10 +24,48 @@
 using namespace pj;
 
+class MyAccount;
+
+class MyCall : public Call
+{
+private:
+    MyAccount *myAcc;
+
+public:
+    MyCall(Account &acc, int call_id = PJSUA_INVALID_ID)
+    : Call(acc, call_id)
+    {
+        myAcc = (MyAccount *)&acc;
+    }
+    
+    virtual void onCallState(OnCallStateParam &prm);
+};
+
 class MyAccount : public Account
 {
+public:
+    std::vector<Call *> calls;
+    
 public:
     MyAccount()
     {}
 
+    ~MyAccount()
+    {
+        std::cout << "*** Account is being deleted: No of calls="
+                  << calls.size() << std::endl;
+    }
+    
+    void removeCall(Call *call)
+    {
+        for (std::vector<Call *>::iterator it = calls.begin();
+             it != calls.end(); ++it)
+        {
+            if (*it == call) {
+                calls.erase(it);
+                break;
+            }
+        }
+    }
+
     virtual void onRegState(OnRegStateParam &prm)
     {
@@ -36,5 +74,32 @@
 		  << prm.code << std::endl;
     }
+    
+    virtual void onIncomingCall(OnIncomingCallParam &iprm)
+    {
+        Call *call = new MyCall(*this, iprm.callId);
+        CallInfo ci = call->getInfo();
+        CallOpParam prm;
+        
+        std::cout << "*** Incoming Call: " <<  ci.remoteURI << " ["
+                  << ci.stateText << "]" << std::endl;
+        
+        calls.push_back(call);
+        prm.statusCode = (pjsip_status_code)200;
+        call->answer(prm);
+    }
 };
+
+void MyCall::onCallState(OnCallStateParam &prm)
+{
+    CallInfo ci = getInfo();
+    std::cout << "*** Call: " <<  ci.remoteURI << " [" << ci.stateText
+              << "]" << std::endl;
+    
+    if (ci.state == PJSIP_INV_STATE_DISCONNECTED) {
+        myAcc->removeCall(this);
+        /* Delete the call */
+        delete this;
+    }
+}
 
 static void mainProg1() throw(Error)
@@ -65,9 +130,22 @@
     acc_cfg.sipConfig.authCreds.push_back( AuthCredInfo("digest", "*",
                                                         "test1", 0, "test1") );
-    std::auto_ptr<Account> acc(new MyAccount);
+    std::auto_ptr<MyAccount> acc(new MyAccount);
     acc->create(acc_cfg);
-
+    
     pj_thread_sleep(2000);
-
+    
+    // Make outgoing call
+    Call *call = new MyCall(*acc);
+    acc->calls.push_back(call);
+    CallOpParam prm(true);
+    prm.opt.audioCount = 1;
+    prm.opt.videoCount = 0;
+    call->makeCall("sip:test1@pjsip.org", prm);
+    
+    // Hangup all calls
+    pj_thread_sleep(8000);
+    ep.hangupAllCalls();
+    pj_thread_sleep(4000);
+    
     // Destroy library
     std::cout << "*** PJSUA2 SHUTTING DOWN ***" << std::endl;
@@ -190,5 +268,5 @@
 
     try {
-	mainProg();
+	mainProg1();
 	std::cout << "Success" << std::endl;
     } catch (Error & err) {
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/java/Makefile
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/java/Makefile	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/java/Makefile	(revision 4663)
@@ -1,3 +1,7 @@
 include ../../../../build.mak
+
+ifneq ($(findstring "$(TARGET_NAME)","darwin"),"")
+  OS=darwin
+endif
 
 OUT_DIR=output
@@ -5,5 +9,9 @@
 LIBPJSUA2_SO=$(OUT_DIR)/pjsua2.dll
 else
-LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.so
+  ifeq ($(OS),darwin)
+    LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.jnilib
+  else
+    LIBPJSUA2_SO=$(OUT_DIR)/libpjsua2.so
+  endif
 endif
 
@@ -23,10 +31,13 @@
 # OS specific
 ifeq ($(OS),Windows_NT)
-MY_JNI_LDFLAGS	 = -L$(MY_JDK)/lib -Wl,--kill-at
-MY_JNI_LIB       = $(OUT_DIR)/pjsua2.dll
+  MY_JNI_LDFLAGS	 = -L$(MY_JDK)/lib -Wl,--kill-at
+  MY_JNI_LIB       = $(OUT_DIR)/pjsua2.dll
 else
-MY_JNI_LDFLAGS	 = -L$(MY_JDK)/lib -Wl,-soname,pjsua2.so
-MY_JNI_LIB       = $(OUT_DIR)/libpjsua2.so
-MY_JNI_CFLAGS	 := -fPIC
+  MY_JNI_LDFLAGS	 = -L$(MY_JDK)/lib
+  ifneq ($(OS),darwin)
+    MY_JNI_LDFLAGS := $(MY_JNI_LDFLAGS) -Wl,-soname,pjsua2.so
+  endif
+  MY_JNI_LIB       = $(OUT_DIR)/libpjsua2.so
+  MY_JNI_CFLAGS	 := -fPIC $(MY_JNI_CFLAGS)
 endif
 
@@ -34,6 +45,11 @@
 MY_SWIG		 = swig
 MY_JDK		 = $(JAVA_HOME)
-MY_JAVA		 = $(MY_JDK)/bin/java
-MY_JAVAC	 = $(MY_JDK)/bin/javac
+ifneq ($(findstring $(JAVA_BIN), bin),)
+  MY_JAVA	 = $(MY_JDK)/bin/java
+  MY_JAVAC	 = $(MY_JDK)/bin/javac
+else
+  MY_JAVA	 = $(MY_JDK)/java
+  MY_JAVAC	 = $(MY_JDK)/javac
+endif
 MY_JNI_CFLAGS	 := $(MY_JNI_CFLAGS) -I$(MY_JDK)/include -I$(MY_JDK)/include/win32 \
 		   -I$(MY_JDK)/include/linux -I.
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/pjsua2.i
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/pjsua2.i	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/pjsua2.i	(revision 4663)
@@ -37,4 +37,5 @@
 %feature("director") Endpoint; 
 %feature("director") Account;
+%feature("director") Call;
 %feature("director") Buddy;
 %feature("director") FindBuddyMatch;
@@ -79,4 +80,7 @@
 %include "pjsua2/presence.hpp"
 %include "pjsua2/account.hpp"
+%include "pjsua2/call.hpp"
+
+%template(CallMediaInfoVector)          std::vector<pj::CallMediaInfo>;
 
 %ignore pj::JsonDocument::allocElement;
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/python/setup.py
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/python/setup.py	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/python/setup.py	(revision 4663)
@@ -93,5 +93,6 @@
     # Mac OS X depedencies
     extra_link_args += ["-framework", "CoreFoundation", 
-                        "-framework", "AudioToolbox"]
+                        "-framework", "AudioToolbox",
+			"-framework", "QTKit"]
     # OS X Lion support
     if platform.mac_ver()[0].startswith("10.7"):
Index: pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/symbols.lst
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/symbols.lst	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip-apps/src/swig/symbols.lst	(revision 4663)
@@ -1,3 +1,3 @@
-pj/types.h			pj_status_t pj_constants_ pj_uint8_t pj_int32_t         
+pj/types.h			pj_status_t pj_constants_ pj_uint8_t pj_int32_t pj_uint32_t pj_uint16_t
 pj/file_io.h			pj_file_access
 pj/log.h			pj_log_decoration
@@ -8,18 +8,26 @@
 pjnath/turn_session.h          	pj_turn_tp_type
 
-pjmedia/transport_srtp.h     	pjmedia_srtp_use
-pjmedia/vid_stream.h          	pjmedia_vid_stream_rc_method
-pjmedia-videodev/videodev.h     pjmedia_vid_dev_index pjmedia_vid_dev_std_index
+pjmedia/event.h                 pjmedia_event_type
+pjmedia/transport_srtp.h	pjmedia_srtp_use
+pjmedia/vid_stream.h		pjmedia_vid_stream_rc_method
+pjmedia-videodev/videodev.h	pjmedia_vid_dev_index pjmedia_vid_dev_std_index
 pjmedia/wav_port.h              pjmedia_file_writer_option pjmedia_file_player_option
-pjmedia/types.h                 pjmedia_type
+pjmedia/types.h                 pjmedia_type pjmedia_dir pjmedia_tp_proto
 pjmedia/format.h		pjmedia_format_id
 
-pjsip/sip_auth.h          	pjsip_cred_data_type
-pjsip/sip_msg.h               	pjsip_status_code
-pjsip/sip_transport.h          	pjsip_transport_type_e pjsip_transport_flags_e pjsip_transport_state
-pjsip/sip_transport_tls.h     	pjsip_ssl_method
+pjsip/sip_auth.h		pjsip_cred_data_type
+pjsip/sip_dialog.h              pjsip_dialog_cap_status
+pjsip/sip_event.h               pjsip_event_id_e
+pjsip/sip_msg.h			pjsip_status_code pjsip_hdr_e
+pjsip/sip_transport.h		pjsip_transport_type_e pjsip_transport_flags_e pjsip_transport_state
+pjsip/sip_transport_tls.h	pjsip_ssl_method
+pjsip/sip_transaction.h         pjsip_tsx_state_e
+pjsip/sip_types.h               pjsip_role_e
+pjsip/sip_util.h                pjsip_redirect_op
 
 pjsip-simple/rpid.h          	pjrpid_activity
 pjsip-simple/evsub.h		pjsip_evsub_state
 
-pjsua-lib/pjsua.h		pjsua_invalid_id_const_ pjsua_state pjsua_stun_use pjsua_call_hold_type pjsua_acc_id pjsua_destroy_flag pjsua_100rel_use pjsua_sip_timer_use pjsua_ipv6_use pjsua_buddy_status
+pjsip-ua/sip_inv.h              pjsip_inv_state
+
+pjsua-lib/pjsua.h		pjsua_invalid_id_const_ pjsua_state pjsua_stun_use pjsua_call_hold_type pjsua_acc_id pjsua_destroy_flag pjsua_100rel_use pjsua_sip_timer_use pjsua_ipv6_use pjsua_buddy_status pjsua_call_media_status pjsua_vid_win_id pjsua_call_id pjsua_med_tp_st pjsua_call_vid_strm_op pjsua_vid_req_keyframe_method pjsua_call_flag pjsua_create_media_transport_flag
Index: pjproject/branches/projects/pjsua2/pjsip/build/Makefile
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/build/Makefile	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/build/Makefile	(revision 4663)
@@ -91,5 +91,5 @@
 export PJSUA2_LIB_OBJS += $(OS_OBJS) $(M_OBJS) $(CC_OBJS) $(HOST_OBJS) \
 			   account.o endpoint.o json.o persistent.o types.o \
-			   siptypes.o presence.o media.o
+			   siptypes.o call.o presence.o media.o
 export PJSUA2_LIB_CFLAGS += $(_CFLAGS) $(PJ_VIDEO_CFLAGS)
 export PJSUA2_LIB_CXXFLAGS = $(PJSUA2_LIB_CFLAGS) 
Index: pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp
===================================================================
--- pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp	(revision 4662)
+++ pjproject/branches/projects/pjsua2/pjsip/include/pjsua2.hpp	(revision 4663)
@@ -22,4 +22,5 @@
 #include <pjsua2/endpoint.hpp>
 #include <pjsua2/account.hpp>
+#include <pjsua2/call.hpp>
 #include <pjsua2/presence.hpp>
 #include <pjsua2/media.hpp>
